// ChildFrm.cpp : implementation of the CChildFrame class
//

#include "stdafx.h"
#include "MDILayout.h"

#include "ChildFrm.h"

#include "MDILayoutDoc.h"
#include "TitleFormView.h"
#include "DisplayView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChildFrame
static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
		ID_INDICATOR_CAPS,
		ID_INDICATOR_NUM,
		ID_INDICATOR_SCRL,
};

IMPLEMENT_DYNCREATE(CChildFrame, CMDIChildWnd)

BEGIN_MESSAGE_MAP(CChildFrame, CMDIChildWnd)
	//{{AFX_MSG_MAP(CChildFrame)
	ON_WM_CREATE()
	ON_UPDATE_COMMAND_UI(ID_BUTTON1, OnUpdateTBarButtons)
	ON_UPDATE_COMMAND_UI(ID_BUTTON2, OnUpdateTBarButtons)
	ON_UPDATE_COMMAND_UI(ID_BUTTON3, OnUpdateTBarButtons)
	ON_UPDATE_COMMAND_UI(ID_BUTTON4, OnUpdateTBarButtons)
	ON_UPDATE_COMMAND_UI(ID_BUTTON5, OnUpdateTBarButtons)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChildFrame construction/destruction

CChildFrame::CChildFrame()
{
	// TODO: add member initialization code here
	
}

CChildFrame::~CChildFrame()
{
}

/////////////////////////////////////////////////////////////////////////////
// CChildFrame diagnostics

#ifdef _DEBUG
void CChildFrame::AssertValid() const
{
	CMDIChildWnd::AssertValid();
}

void CChildFrame::Dump(CDumpContext& dc) const
{
	CMDIChildWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CChildFrame message handlers

int CChildFrame::CreatePanes(CCreateContext *pContext)
{
	/**** JohnCz ***/
	// creating views

	pContext->m_pNewViewClass = RUNTIME_CLASS(CTitleFormView);
	
	CWnd *pWnd = CreateView(pContext, AFX_IDW_PANE_FIRST + 1); // cannot be AFX_IDW_PANE_FIRST
	
	if(!pWnd)
	{
		TRACE("Failed to create view pane for %s class.\n", pContext->m_pNewViewClass->m_lpszClassName);
		return -1;
	}
	pWnd->SetWindowPos(&wndBottom, 0, 0, 0, 0, SWP_NOSIZE);

	pContext->m_pNewViewClass = RUNTIME_CLASS(CDisplayView);	  
	
	pWnd = CreateView(pContext, AFX_IDW_PANE_FIRST + 2); // cannot be AFX_IDW_PANE_FIRST
	
	if(!pWnd)
	{
		TRACE("Failed to create view pane for %s class.\n", pContext->m_pNewViewClass->m_lpszClassName);
		return -1;
	}
	pWnd->SetWindowPos(&wndBottom, 0, 0, 0, 0, SWP_NOSIZE);
	return 0;
}

int CChildFrame::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CMDIChildWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_CHILDFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;		// fail to create
	}

	// TODO: Delete these three lines if you don't want the toolbar to
	//	be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);
	
/*
	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;		// fail to create
	}
	*/
	
	
	
	/**** JohnCz ***/
	// Other panes created here to make sure 
	// they will be created after bars in Z order for proper layout
	// layour computation works for both scenarios: with and without bars
	MDICREATESTRUCT *pmdic = (MDICREATESTRUCT*)lpCreateStruct->lpCreateParams;
	CCreateContext *pContext = (CCreateContext*)pmdic->lParam;
	if(-1 == CreatePanes(pContext))
	{
		return -1;
	}


	return 0;
}


void CChildFrame::OnUpdateTBarButtons(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable();
}
